#pragma once
#include <ppl.h>
#include <sstream>
#include <iostream>

// ҽ ߻ȭ Ŭ
class Resource
{
public:
    Resource(const std::wstring& name)
        : _name(name)
    {
    }

    // ҽ  ޼ҵ
    void cleanup()
    {
        // ҽ  ùķ̼
        std::wstringstream ss;
        ss << _name << L": Freeing..." << std::endl;
        std::wcout << ss.str();
    }
private:
    // ҽ
    std::wstring _name;
};

// ҽ  ̳ʸ ߻ȭ Ŭ
class Container
{
public:
    Container(const std::wstring& name)
        : _name(name)
        , _resource1(L"Resource 1")
        , _resource2(L"Resource 2")
        , _resource3(L"Resource 3")
    {
    }

    ~Container()
    {
        std::wstringstream ss;
        ss << _name << L": Freeing resources..." << std::endl;
        std::wcout << ss.str();

        // _resource1, _resource2  ۾  ó
        Concurrency::parallel_invoke(
            [this]() { _resource1.cleanup(); },
            [this]() { _resource2.cleanup(); }
        );

        //  ۾ ϷǸ _resource3 
        _resource3.cleanup();
    }

private:
    // ̳ʸ
    std::wstring _name;

    // ̳ʰ ϴ ҽ
    Resource _resource1;
    Resource _resource2;
    Resource _resource3;
};
